$PBExportHeader$n_cst_dwsrv_multitable.sru
$PBExportComments$Extension DataWindow Multiple Table service
forward
global type n_cst_dwsrv_multitable from pfc_n_cst_dwsrv_multitable
end type
end forward

global type n_cst_dwsrv_multitable from pfc_n_cst_dwsrv_multitable
end type
global n_cst_dwsrv_multitable n_cst_dwsrv_multitable

type variables
constant	int	ii_Update_Type_Insert#	= 1
constant	int	ii_Update_Type_Delete#	= 2
constant	int	ii_Update_Type_Update#	= 4
constant	int	ii_Update_Type_All#	= 0

PROTECTED:

int	ii_UpdateType[]	// update type for each table.
int	ii_TableIndex			// the table being updated.  used in of_sqlpreview
string	is_QuoteToUse	= "'"		// the quote to use when putting quotes around data
string	is_FormatDate	= 'YYYY-MM-DD'	// the date format to use
string	is_FormatTime	= 'HH:MM:SS.ffff'	// the time format to use
string	is_FormatDateTime	= 'YYYY-MM-DD HH:MM:SS.ffffff'	// the date time format to use
end variables
forward prototypes
public function integer of_update (boolean ab_accepttext, boolean ab_resetflags)
protected function integer of_restoreupdatesettings (os_updcharacteristics astr_originalupdate)
public function integer of_sqlpreview (readonly sqlpreviewfunction request, readonly sqlpreviewtype sqltype, readonly string sqlsyntax, readonly dwbuffer buffer, readonly long row)
public function string of_prot_sql_assignment (readonly long al_row, readonly string as_columnname)
public function string of_prot_sql_expression (readonly long al_row, readonly string as_columnname)
public function integer of_format_set_quote (readonly string as_quote)
public function integer of_format_set_time (readonly string as_formattime)
public function integer of_format_set_date (readonly string as_formatdate)
public function integer of_format_set_datetime (readonly string as_formatdatetime)
public function integer of_setupdatetype (readonly integer ai_updatetype)
protected function integer of_prot_sql_update (readonly long al_row)
protected function string of_prot_get_value (readonly long al_row, readonly string as_columnname)
end prototypes

public function integer of_update (boolean ab_accepttext, boolean ab_resetflags);/*

Purpose:		Duplicated and amended from ancestor object.
				All changes surrounded by 'DVL - 31-May-1998'.

Parameters:	see below

Results:		see below

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/


//////////////////////////////////////////////////////////////////////////////
//
//	Function:  		of_Update (Format 3)
//
//	Access:   		Public
//
//	Arguments:
//  ab_accepttext:	A boolean value specifying whether the DataWindow control
//							should automatically perform an AcceptText prior to 
//							performing the update:
//								TRUE  -- Perform AcceptText
//								FALSE -- Do not perform AcceptText
//  ab_resetflags:	A boolean value specifying whether datawindow should
//							automatically reset the update flags:
//								TRUE  -- Reset the flags
//								FALSE -- Do not reset the flags
//
//	Returns:  			Integer
//    					 1 if it succeeds
//							-1 if an update error occurs.
//    					-2 if the Modify for Update Characteristics failed
//
//	Description:  		Update the datawindow for all the registered tables.
//
//////////////////////////////////////////////////////////////////////////////
//
//	Revision History
//
//	Version
//	5.0   Initial version
//
//////////////////////////////////////////////////////////////////////////////
//
//	Copyright  1996-1997 Sybase, Inc. and its subsidiaries.  All rights reserved.
//	Any distribution of the PowerBuilder Foundation Classes (PFC)
//	source code by other than Sybase, Inc. and its subsidiaries is prohibited.
//
//////////////////////////////////////////////////////////////////////////////

integer	li_num_tables
integer	li_num_cols
integer	li_tabidx
integer	li_updcolidx
integer	li_keycolidx
integer	li_i
integer	li_rc
integer	li_num_updateable
integer	li_num_keys
boolean	lb_is_updateable
boolean	lb_is_key
string	ls_column
string	ls_mod_string
os_updcharacteristics	lstr_originalupdate

// Verify passed arguments.
IF IsNull (ab_accepttext) THEN Return -1
IF IsNull (ab_resetflags) THEN Return -1

// Get the number of tables involved.
li_num_tables = UpperBound (istr_newupdate) 
IF li_num_tables = 0 THEN Return -2

// First save the original update characteristics for later restoration.
li_rc = of_StoreUpdateSettings ( lstr_originalupdate )
If li_rc < 0 Then Return li_rc

// Get the number of columns on the datawindow.
li_num_cols = Integer (idw_Requestor.Describe ( "DataWindow.Column.Count" )) 

// Loop thru each table that is registered, modify the characteristics and update.
FOR li_tabidx = 1 to li_num_tables

	// Set the Update Table.
	ls_mod_string = "DataWindow.Table.UpdateTable='" + &
						 istr_newupdate[li_tabidx].s_updatetable +"' "
	
	// Set the Update Where Option.
	ls_mod_string = ls_mod_string + &
						 "DataWindow.Table.UpdateWhere=" + &
						 String(istr_newupdate[li_tabidx].i_whereoption) +" " 
	
	// Set the Update Key in Place flag.
	If istr_newupdate[li_tabidx].b_keyupdateinplace THEN
		ls_mod_string = ls_mod_string + "DataWindow.Table.UpdateKeyInPlace=yes " 
	Else
		ls_mod_string = ls_mod_string + "DataWindow.Table.UpdateKeyInPlace=no " 
	End If
	
	// Get the number of UpdateColumns and Keys.
	li_num_updateable = UpperBound ( istr_newupdate[li_tabidx].s_updatecolumns )
	li_num_keys = UpperBound ( istr_newupdate[li_tabidx].s_keycolumns )

	// Loop around all columns.
	FOR li_updcolidx = 1 to li_num_cols
		ls_column = idw_Requestor.Describe ( "#" + String(li_updcolidx) + ".Name" )

		//Determine if this column should be Updatable.
		lb_is_updateable = FALSE	
		FOR li_i = 1 to li_num_updateable
			IF Lower(ls_column) = Lower(istr_newupdate[li_tabidx].s_updatecolumns[li_i]) THEN 
				lb_is_updateable = TRUE
				EXIT
			END IF 
		NEXT 
		// Set the Updatable flag as appropriate.
		IF lb_is_updateable THEN 
			ls_mod_string = ls_mod_string + ls_column + ".Update=Yes " 
		ELSE
			ls_mod_string = ls_mod_string + ls_column + ".Update=No " 
		END IF 

		// Determine if this column should be a Key.
		lb_is_key = FALSE		
		FOR li_keycolidx = 1 to li_num_keys
			IF Lower(ls_column) = Lower(istr_newupdate[li_tabidx].s_keycolumns[li_keycolidx]) THEN 
				lb_is_key = TRUE
				EXIT
			END IF 
		NEXT 
		// Set the Key flag as appropriate.		
		IF lb_is_key THEN 
			ls_mod_string = ls_mod_string + ls_column + ".Key=Yes " 
		ELSE
			ls_mod_string = ls_mod_string + ls_column + ".Key=No " 
		END IF 
	NEXT

	// Modify the datawindow object.
	IF idw_Requestor.Modify ( ls_mod_string ) <> "" THEN Return -2

	// DVL - 31-May-1998 BEGIN ********************************************
	//
	// Store the index for sqlpreview
	this.ii_TableIndex = li_tabidx
	//
	// DVL - 31-May-1998 END ********************************************

	// Update the DataWindow, Make sure the Flags are Not Reset.
	li_rc = idw_Requestor.Update ( ab_accepttext, FALSE ) 
	IF li_rc <> 1 THEN Return li_rc 

NEXT 

// DVL - 31-May-1998 BEGIN ********************************************
//
// Clear out the index for sqlpreview
this.ii_TableIndex = 0
//
// DVL - 31-May-1998 END ********************************************

// Restore the update characteristics to their original settings.
li_rc = of_RestoreUpdateSettings ( lstr_originalupdate ) 
If li_rc < 0 Then Return li_rc

// All updates have succesfully occurred, Reset the flags if appropriate.
IF ab_resetflags = TRUE THEN idw_Requestor.ResetUpdate ( ) 

Return 1
end function

protected function integer of_restoreupdatesettings (os_updcharacteristics astr_originalupdate);/*

Purpose:		Duplicated from ancestor object.  No code changed.
				This function cannot be called from a descendant as the
				parameter astr_originalupdate is passed by value.  Passing 
				by reference would work.  This is a limitation of the 
				PowerScript compiler.

Parameters:	see below

Results:		see below

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/




/////////////////////////////////////////////////////////////////////////////
//
//	Function:		of_RestoreUpdateSettings
//
//	Access: 			Protected
//
//	Arguments: 		
//	astr_originalupdate 	Original Update information.
//
//	Returns:   		Integer
// 				  	 1 = The Update Characteristics were successfully reset.
//						-1 = The Modify for Update Characteristics failed.
//
//	Description:  	To reset the datawindow's Update Characteristics to their
//					  	original values.   Called by of_update().
//
//////////////////////////////////////////////////////////////////////////////
//
//	Revision History
//
//	Version
//	5.0   Initial version
//
//////////////////////////////////////////////////////////////////////////////
//
//	Copyright  1996-1997 Sybase, Inc. and its subsidiaries.  All rights reserved.
//	Any distribution of the PowerBuilder Foundation Classes (PFC)
//	source code by other than Sybase, Inc. and its subsidiaries is prohibited.
//
//////////////////////////////////////////////////////////////////////////////
integer	li_num_cols
integer	li_num_updateable
integer	li_num_keys
integer	li_colidx
integer	li_keycolidx
integer	li_updcolidx
string	ls_mod_string=''
string	ls_column
string	ls_yes_no
boolean	lb_found

// Check the datawindow reference.
If IsNull(idw_Requestor) Or Not IsValid(idw_Requestor) Then Return -1

// Restore the Update Table.
ls_mod_string = "DataWindow.Table.UpdateTable='" + astr_originalupdate.s_updatetable + "' "

// Restore the Update Where statement.
ls_mod_string = ls_mod_string + &
					 "DataWindow.Table.UpdateWhere=" + String(astr_originalupdate.i_whereoption) + " "

// Restore the Update Key In Place flag.
If astr_originalupdate.b_keyupdateinplace Then
	ls_mod_string = ls_mod_string + "DataWindow.Table.UpdateKeyInPlace=yes "  
Else
	ls_mod_string = ls_mod_string + "DataWindow.Table.UpdateKeyInPlace=no "
End If

//Set the original updateable columns and key columns
li_num_updateable = UpperBound (astr_originalupdate.s_updatecolumns) 
li_num_keys = UpperBound (astr_originalupdate.s_keycolumns) 

// Loop thru all the datawindow columns to Restore the Updateable and Key flags.
li_num_cols = Integer(idw_Requestor.Describe ( "DataWindow.Column.Count" ) )
FOR li_colidx = 1 to li_num_cols
	//Get the column name.
	ls_column = idw_Requestor.Describe ( "#" + String(li_colidx) + ".Name" )
	
	// See if the column was marked as an updateable column.
	lb_found = FALSE	
	FOR li_updcolidx = 1 to li_num_updateable 
		IF astr_originalupdate.s_updatecolumns [li_updcolidx] = ls_column THEN 
			lb_found = TRUE
			Exit
		END IF 
	NEXT
	// Restore the Updateable Flag
	IF lb_found THEN 
		ls_mod_string = ls_mod_string + ls_column + ".Update=Yes "
	Else
		ls_mod_string = ls_mod_string + ls_column + ".Update=No "
	END IF
	
	// See if the column was marked as a key column
	lb_found = FALSE	
	FOR li_keycolidx = 1 to li_num_keys
		IF astr_originalupdate.s_keycolumns [li_keycolidx] = ls_column THEN 
			lb_found = TRUE
			Exit
		END IF 
	NEXT
	// Restore the Key column flag
	IF lb_found THEN 
		ls_mod_string = ls_mod_string + ls_column + ".Key=Yes "
	ELSE 		
		ls_mod_string = ls_mod_string + ls_column + ".Key=No "
	END IF 
NEXT  

// Modify the requesting datawindow with the original
// update characteristics
IF idw_Requestor.Modify ( ls_mod_string ) <> "" THEN Return -1

Return 1
end function

public function integer of_sqlpreview (readonly sqlpreviewfunction request, readonly sqlpreviewtype sqltype, readonly string sqlsyntax, readonly dwbuffer buffer, readonly long row);/*

Purpose:		Reject or modify the SQL for this row based upon the
				parameters we have been given.

Parameters:	see datawindow::sqlpreview for full details

				request		- The function that initiated the database activity.
				sqltype		- The type of SQL statement being sent to the DBMS.
				sqlsyntax	- The full text of the SQL statement.
				buffer		- The buffer containing the row involved in the database activity.
				row			- The number of the row involved in the database activity, that is, 
								  the row being updated, selected, inserted, or deleted.

Results:		

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Result = 0 // presume that the SQL will go ahead.
int	li_UpdateType

n_cst_numerical	lnv_Numerical	// for bitwise operations

if this.ii_TableIndex = 0 then
	// we aren't in the middle of an update.
	return 0
end if

if UpperBound(this.ii_UpdateType) < this.ii_TableIndex then
	// we haven't been told about this table, so we ignore it.
	return 0
end if

li_UpdateType = this.ii_UpdateType[this.ii_TableIndex]

CHOOSE CASE request
	CASE PreviewFunctionUpdate!
		// we're doing an update.  does this table allow that type of update?

		CHOOSE CASE sqltype
			CASE PreviewDelete!
				if lnv_Numerical.of_BitwiseAND(li_UpdateType, this.ii_Update_Type_Delete#) = 0 AND li_UpdateType <> this.ii_Update_Type_All# then
					// deletes are not allowed.  skip this request and go onto the next request.
					li_Result = 2
				end if
				
			CASE PreviewUpdate!
				if lnv_Numerical.of_BitwiseAND(li_UpdateType, this.ii_Update_Type_Update#) = 0  AND li_UpdateType <> this.ii_Update_Type_All# then
					// Updates are not allowed.  skip this request and go onto the next request.
					li_Result = 2
				end if
				
			CASE PreviewInsert!
				if lnv_Numerical.of_BitwiseAND(li_UpdateType, this.ii_Update_Type_Insert#) = 0  AND li_UpdateType <> this.ii_Update_Type_All# then
					// we don't allow inserts
					// do we allow updates?
					if lnv_Numerical.of_BitwiseAND(li_UpdateType, this.ii_Update_Type_Update#) = 0  AND li_UpdateType <> this.ii_Update_Type_All# then
						li_Result = 2	// neither inserts nor updates are not allowed.  skip this request.
					else
						// we can't insert, but we can update.  therefore, we'll create an update string
						li_Result = this.of_prot_SQL_Update ( row )
					end if
				end if
				
		END CHOOSE

END CHOOSE

return li_Result
end function
public function string of_prot_sql_assignment (readonly long al_row, readonly string as_columnname);/*

Purpose:		return a string which can be used to assign a value to a column
				within an SQL statement.  Normally, this string would be used as part
				of an UPDATE statement.

				see also of_prof_SQL_Expression.

Parameters:	al_row			- the row from which to obtain the value
				as_columnname	- the column from which to obtain the value

Results:		

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

string	ls_Value
string	ls_DBName
string	ls_Result

// we must have the database name, not the datawindow name
ls_DBName = this.idw_Requestor.Describe(as_ColumnName + '.dbName')

// get the value for this column
ls_Value = this.of_prot_Get_Value(al_Row, as_ColumnName)

// here's what we return.
ls_Result = ls_DBName + ' = ' + ls_Value

return ls_Result
end function

public function string of_prot_sql_expression (readonly long al_row, readonly string as_columnname);/*

Purpose:		return a string which can be used in an expression.  Normally, this 
				string would be used as part of a WHERE clause..

				see also of_prof_SQL_Assignment.

Parameters:	al_row			- the row from which to obtain the value
				as_columnname	- the column from which to obtain the value

Results:		

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

string	ls_Value
string	ls_Result
string	ls_DBName

// we must have the database name, not the datawindow name
ls_DBName	= this.idw_Requestor.Describe(as_ColumnName + '.dbName')

// get the value for this column
ls_Value		= this.of_prot_Get_Value(al_Row, as_ColumnName)

// if it's null, use IS NULL.
if IsNull(ls_Value) then
	ls_Result = ls_DBName + ' IS NULL'
else
	ls_Result = ls_DBName + ' = ' + ls_Value 
end if

return ls_Result
end function

public function integer of_format_set_quote (readonly string as_quote);/*

Purpose:		set the quote character to be used when putting quotes around strings, dates, etc.

Parameters:	as_Quote - the quote character you want to use.  Presumably this would be either ' or ".

Results:		1 for success, -1 otherwise

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Result = 1	// presume success

if IsNull(as_Quote) then
	li_Result = -1
else
	this.is_QuoteToUse = as_Quote
end if

return li_Result
end function

public function integer of_format_set_time (readonly string as_formattime);/*

Purpose:		set the time format to be used when converting time value to strings.

Parameters:	as_FormatTime - for example 'HH:MM:SS'

Results:		1 for success, -1 otherwise

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Result = 1	// presume success

if IsNull(as_FormatTime) then
	li_Result = -1
else
	this.is_FormatTime = as_FormatTime
end if

return li_Result
end function

public function integer of_format_set_date (readonly string as_formatdate);/*

Purpose:		set the Date format to be used when converting Date value to strings.

Parameters:	as_FormatDate - for example 'YYYY-MM-DD'

Results:		1 for success, -1 otherwise

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Result = 1	// presume success

if IsNull(as_FormatDate) then
	li_Result = -1
else
	this.is_FormatDate = as_FormatDate
end if

return li_Result
end function

public function integer of_format_set_datetime (readonly string as_formatdatetime);/*

Purpose:		set the DateTime format to be used when converting dateDateTime or DateTimestamp value to strings.

Parameters:	as_FormatDateTime - for example 'YYYY-MM-DD HH:MM:SS'

Results:		1 for success, -1 otherwise

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Result = 1	// presume success

if IsNull(as_FormatDateTime) then
	li_Result = -1
else
	this.is_FormatDateTime = as_FormatDateTime
end if

return li_Result
end function

public function integer of_setupdatetype (readonly integer ai_updatetype);/*

Purpose:		

Parameters:	

Results:		

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int	li_Index
int	li_Result = 1	// presume success

// this needs to be one for of_GetItem in 
this.idw_Requestor.of_SetBase(TRUE)

li_Index = UpperBound(this.istr_newupdate)
this.ii_UpdateType[li_Index] = ai_UpdateType

return li_Result
end function

protected function integer of_prot_sql_update (readonly long al_row);/*

Purpose:		Create an UPDATE statement for the row in question.

Parameters:	al_row - the row for which you need an UPDATE statement.

Results:		0 - default, continue
				1 - stop
				2 - Skip this request and execute the next request.
				
				For details, search for DataWindow controls in the online help,
				click on the Events button, scroll down to the SQLPreview event.

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

int				li_Result		= 0 // presume we'll continue with this request
int				li_Column
int				li_ColumnCount
dwItemStatus	ldwis_Status

string			ls_Set
string			ls_Update
string			ls_Where
string			ls_ColumnName

os_updCharacteristics	lstr_Update

// what we need to do is create our own SQL.
// we know the row is new.  We just have to find out which columns are changed.

lstr_Update = this.istr_newupdate[this.ii_TableIndex]
li_ColumnCount = UpperBound(lstr_Update.s_updatecolumns)
for li_Column = 1 to li_ColumnCount
	ldwis_Status = this.idw_Requestor.GetItemStatus(al_Row, li_Column, Primary!)
	if ldwis_Status = DataModified! then
		ls_ColumnName = lstr_Update.s_Updatecolumns[li_Column]
		ls_Set += this.of_prot_sql_assignment ( al_Row, ls_ColumnName ) + ', '
	end if
end for

if ls_Set <> '' then
	// we have things to update
	// get rid of the final comma
	ls_Set = left(ls_Set, len(ls_Set) - 2)
	li_ColumnCount = UpperBound(lstr_Update.s_keycolumns)
	for li_Column = 1 to li_ColumnCount
		ls_ColumnName = lstr_Update.s_keycolumns[li_Column]
		ls_Where += this.of_prot_sql_Expression ( al_Row, ls_ColumnName ) + ' and '
	end for
	
	// get rid of the final 'and'
	ls_Where = left(ls_Where, len(ls_Where) - 5)
	
	ls_Update = 'UPDATE ' + this.istr_newupdate[this.ii_TableIndex].s_updatetable + ' SET ' + &
						ls_Set + ' WHERE ' + ls_Where
	
	if this.idw_Requestor.SetSQLPreview(ls_Update) = 1 then
		// success!
	else
		// ooops!
		MessageBox('Internal error', this.ClassName() + '::of_SQLPreview was unable to set the SQL.', StopSign!)

		// stop
		li_Result = 1
	end if
else
	// nothing to update, ignore this request and go onto the next request.
	li_Result = 2
end if

return li_Result
end function

protected function string of_prot_get_value (readonly long al_row, readonly string as_columnname);/*

Purpose:		Obtain a value from the datawindow and return it as a string

Parameters:	al_row			- the row from which to obtain the value
				as_columnname	- the name of the column from which to obtain the value

Results:		String which represents the item in question.
				The format depends upon the value of the respective format string.
				See the various of_Format_Set_* functions for details.

				Some datatypes are surrounded by quotes.  Some aren't (e.g. numeric).

	DVL Software - http://www.dvl-software.com
	You may use, distribute, or modify this code provided you retain this header.

*/

string	ls_ColumnType
string	ls_Value
boolean	lb_Quoted = TRUE		// assume item is to be quoted.

// this will tell us what type of column we are dealing with.
// we only use the first 5 characters because "char(x)" cannot be catered for.

ls_ColumnType = lower(left(this.idw_Requestor.Describe(as_ColumnName + '.ColType'), 5))

// get the value and convert it to a string
CHOOSE CASE ls_ColumnType
	CASE "char("				//  string
		ls_Value = this.idw_Requestor.inv_Base.of_GetItem(al_Row, as_columnname)
	
	CASE "date"					//  date
		ls_Value = String ( idw_Requestor.GetItemDate ( al_row, as_columnName ), this.is_FormatDate )
	
	CASE "datet", "times"	//  datetime or timestamp
		ls_Value = String ( idw_Requestor.GetItemDateTime ( al_row, as_columnName ), this.is_FormatDateTime )
	
	CASE "decim"				//  decimal
		ls_Value = string(idw_Requestor.GetItemDecimal ( al_row, as_columnName ) )
		lb_Quoted = FALSE
	
	CASE "numbe", "long", "ulong", "real"				//  those number things
		ls_Value = string(this.idw_Requestor.GetItemNumber ( al_row, as_columnName))
		lb_Quoted = FALSE
	
	CASE "time"				//  time
		ls_Value = string(this.idw_Requestor.GetItemTime ( al_row, as_columnname ))
	
END CHOOSE

// if this datatype is to be quoted, then quote it.
if lb_Quoted then
	ls_Value = this.is_QuoteToUse + ls_Value + this.is_QuoteToUse
end if

return ls_Value
end function

on n_cst_dwsrv_multitable.create
TriggerEvent( this, "constructor" )
end on

on n_cst_dwsrv_multitable.destroy
TriggerEvent( this, "destructor" )
end on

